'********************************************************************************************************************************************
'*********************************TERMOMETR_WIELOZAKRESOWY***********************************************************************************
'********************************************************************************************************************************************

$regfile = "m8def.dat"

$crystal = 10000000

Config 1wire = Portb.0
Config Pind.3 = Input
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portc.5 , Db5 = Portc.4 , Db6 = Portc.3 , Db7 = Portc.2 , E = Portc.1 , Rs = Portc.0

Portd.3 = 1


Deflcdchar 0 , 6 , 9 , 9 , 6 , 32 , 32 , 32 , 32

Dim T1 As Single
Dim T2 As Single
Dim Poprzedni As Single
Dim B1 As Byte , B2 As Byte , R As Byte
Dim Tmp As String * 6
Dim Znak As Bit
Dim Zmiana As Bit
'I = 0
R = &HFF
Znak = 0
Poprzedni = 300
Zmiana = 1

Cursor Off
Cls

'********************************************************************************************************************************************
'*********************************PETLA_GLOWNA***********************************************************************************************
'********************************************************************************************************************************************


Do
Gosub Celcjusz
Loop
End

'********************************************************************************************************************************************
'*********************************FUNKCJA_WYSWIETLAJACA_W_STOPNIACH_CELSJUSZACH**************************************************************
'********************************************************************************************************************************************


Celcjusz:
Do
Gosub Odczyt
If T1 <> Poprzedni Or Zmiana = 1 Then
Poprzedni = T1

Tmp = Fusing(t1 , "###.&&")
Cls
Lcd "Temperatura:"
Locate 2 , 4

If Znak = 0 Then
Lcd "-"
End If

Lcd Tmp ; Chr(0) ; "C"


End If
Zmiana = 0


If Pind.3 = 0 Then
Waitms 1000
If Pind.3 = 0 Then
Zmiana = 1
Gosub Kelvin
End If
End If
Loop

Return

'********************************************************************************************************************************************
'*********************************FUNKCJA_WYSWIETLAJACA_W_STOPNIACH_KELWINACH****************************************************************
'********************************************************************************************************************************************

Kelvin:
Do

Gosub Odczyt
If T1 <> Poprzedni Or Zmiana = 1 Then
Poprzedni = T1

T1 = T1 + 273
Tmp = Fusing(t1 , "###.&&")
Cls
Lcd "Temperatura:"
Locate 2 , 4
Lcd Tmp ; "K"



End If

Zmiana = 0

If Pind.3 = 0 Then
Waitms 1000
If Pind.3 = 0 Then
Zmiana = 1
Gosub Fahrenheit

End If
End If
Loop

Return


'********************************************************************************************************************************************
'*********************************FUNKCJA_WYSWIETLAJACA_W_STOPNIACH_FAHRENHEITA**************************************************************
'********************************************************************************************************************************************


Fahrenheit:

Do

Gosub Odczyt
If T1 <> Poprzedni Or Zmiana = 1 Then
Poprzedni = T1


Cls
Lcd "Temperatura:"
Locate 2 , 4
If Znak = 0 And T1 > 17.778 Then
Lcd "-"
End If

T1 = 9 * T1
T1 = T1 / 5
T1 = T1 + 32
Tmp = Fusing(t1 , "###.&&")


Lcd Tmp ; Chr(0) ; "F"


End If

Zmiana = 0

If Pind.3 = 0 Then
Waitms 1000
If Pind.3 = 0 Then
Zmiana = 1
Gosub Celcjusz
End If
End If
Loop
Return




'********************************************************************************************************************************************
'*********************************FUNKCJA_ODCZYTU_Z_CZUJNIKA_DS18B20*************************************************************************
'********************************************************************************************************************************************
Odczyt:
1wreset
1wwrite &HCC
1wwrite &H44
Waitms 750
1wreset
1wwrite &HCC
1wwrite &HBE


B1 = 1wread()
B2 = 1wread()

1wreset

If Err = 1 Then
Cls
Lcd "Brak ukladu"
Do

Loop Until Err = 0
End If


If B2 >= 248 Then
B1 = R - B1
B2 = R - B2
Znak = 0
Else
Znak = 1
End If
T1 = B1 / 16
T2 = B2 * 16
T1 = T1 + T2

Return